package function.builtin.predicate;

import static testutil.TestUtilities.evaluateString;
import static testutil.TypeAssertions.assertNil;
import static testutil.TypeAssertions.assertT;

import org.junit.Test;

import function.ArgumentValidator.TooFewArgumentsException;
import function.ArgumentValidator.TooManyArgumentsException;
import testutil.SymbolAndFunctionCleaner;

public class NULLTest extends SymbolAndFunctionCleaner {

    @Test
    public void nilIsNull() {
        assertT(evaluateString("(null ())"));
    }

    @Test
    public void nilIsNullWithAlias() {
        assertT(evaluateString("(null? ())"));
    }

    @Test
    public void listIsNotNull() {
        assertNil(evaluateString("(null '(1))"));
    }

    @Test(expected = TooFewArgumentsException.class)
    public void testNullWithTooFewArguments() {
        evaluateString("(null)");
    }

    @Test(expected = TooManyArgumentsException.class)
    public void testNullWithTooManyArguments() {
        evaluateString("(null 1 2)");
    }

}
